/*
TASK: perm
LANG: C++
*/

#include <cstdio>
#include <vector>
#include <algorithm>

inline void swap(unsigned int& a, unsigned int& b)
{
	a ^= b ^= a ^= b;
}

class more
{
public:
	bool operator() (const unsigned int& a, const unsigned int& b) {return a > b;}
};

int main()
{
	unsigned int n;
	std::scanf("%u", &n);
	std::vector<unsigned int> input(n+1);
	for (unsigned int i = 1; i <= n; i++)
		std::scanf("%u", &(input[i]));
	input[0] = 0;

	std::vector<std::vector<long long unsigned int> > m(n+1);
	for (unsigned int i = 0; i <= n; i++)
	{
		m[i].resize(n, 0);
		m[i][0] = 1;
	}

	m[2][1] = 2; m[2][2] = 2;

	for (unsigned int i = 3; i <= n; i++)
		for (unsigned int j = 1; j <= i && j < n; j++)
			m[i][j] = m[i-1][j] + m[i][j-1];

	std::printf("%llu\n", m[n][n-1]);

	std::vector<unsigned int> max_value(n+1);
	max_value[0] = 0;
	for (unsigned int i = 1; i < n+1; i++)
		max_value[i] = (max_value[i-1] > input[i] ? max_value[i-1] : input[i]);

	std::vector<unsigned int> min_value(n+1);
	min_value.back() = input.back();
	for (unsigned int i = n-1; i > 0; i--)
		min_value[i] = (min_value[i+1] < input[i] ? min_value[i-1] : input[i]);

	unsigned int s = 2;
	while (s < n && (min_value[s] >= input[s] || max_value[s] <= input[s])) s++;
	if (s < n)
	{
		std::vector<unsigned int>::iterator it = input.begin();
		for (unsigned int i = 0; i < s; i++) it++;
		it++;
		for (unsigned int i = s+1; i <= n; i++)
			if (input[i] < input[s])
			{
				swap(input[i], input[s]);
				break;
			}
		std::sort(it, input.end(), more());
	}

	std::vector<unsigned int>::iterator i = input.end(); i--;
	std::vector<unsigned int>::iterator i2 = i;
	std::vector<unsigned int>::iterator max = max_value.end(); max--;
	for (i--, max--; i2 != input.begin(); i--)
	{
		if (*i > *i2)
		{
			i2--;
			max--;
			continue;
		}

		std::vector<unsigned int>::iterator j = input.end();
		std::vector<unsigned int>::iterator k = i;
		for (k++; k != input.end(); k++)
			if (*k > *max && (j == input.end() || *j > *k))
				j = k;

		if (j == input.end())
		{
			i2--;
			max--;
			continue;
		}
		else
		{
			swap(*i, *j);
			i++;
			std::sort(i, input.end());
			break;
		}
	}

	if (!input[1])
		input[1] = 1;

	for (unsigned int i = 1; i <= n; i++)
	{
		if (i != 1) std::printf(" ");
		std::printf("%u", input[i]);
	}
	std::printf("\n");

	return 0;
}
