/*
TASK:PERM
LANG:C
*/
#include<stdio.h>

#define MAXN 64
#define MAXD 50
#define MOD 1000000000

int perm[MAXN],used[MAXN],max,min;

typedef struct num num;

struct num
{
        int d[MAXD],l;
} f[MAXN][MAXN],res;

void set(num *a,int c)
{
        int i;
        for(i=0;i<MAXD;i++) a->d[i]=0;
        a->d[0]=c;
        if(c) a->l=1;
        else a->l=0;
}

void add(num *a,num *b)
{
        int i,take=0,len=(a->l>b->l)?a->l:b->l;
        for(i=0;i<len;i++)
        {
                a->d[i]+=b->d[i];
                if(a->d[i]>=MOD) { a->d[i]-=MOD; take=1; }
                else take=0;
        }
        if(take) a->d[i++]=1;
        a->l=i;
}

void sub(num *a,num *b)
{
        int i,take=0,len=(a->l>b->l)?a->l:b->l;
        for(i=0;i<len;i++)
        {
                a->d[i]-=b->d[i]+take;
                if(a->d[i]<0) { a->d[i]+=MOD; take=1; }
                else take=0;
        }
        i=a->l;
        while(i>0&&a->d[i-1]==0) i--;
        a->l=i;
}

int cmp(num *a,num *b)
{
        int i;
        if(a->l<b->l) return -1;
        if(a->l>b->l) return 1;
        for(i=MAXD-1;i>=0;i--) if(a->d[i]!=b->d[i])
        {
                if(a->d[i]<b->d[i]) return -1;
                else return 1;
        }
        return 0;
}

int print(num *a)
{
        int i;
        if(a->l==0) printf("0");
        else printf("%d",a->d[a->l-1]);
        for(i=a->l-2;i>=0;i--) printf("%d",a->d[i]);
        printf("\n");
}

int main()
{
        int i,j,k,n,p,q;
        scanf("%d",&n);
        for(i=0;i<=n;i++) set(&f[0][i],1);
        for(i=1;i<=n;i++)
        {
                for(j=0;j+i<=n;j++)
                {
                        for(k=1;k<=i;k++) add(&f[i][j],&f[i-k][j+k-1]);
                        if(j) add(&f[i][j],&f[i][j-1]);
                }
        }
        for(i=0;i<n;i++) { scanf("%d",&perm[i]); }
        p=n; q=max=0;
        for(i=0;i<n;i++)
        {
                if(perm[i]<max) q--;
                else
                {
                        add(&res,&f[p][q-1]);
                        for(j=max+1;j<perm[i];j++)
                        {
                                k=j-max;
                                add(&res,&f[p-k][q+k-1]);
                        }
                        p-=j-max;
                        q+=j-max-1;
                        max=perm[i];
                }
        }
        print(&f[n][0]);
        add(&res,&f[0][0]);
        if(cmp(&res,&f[n][0])==0) set(&res,0);
        p=n; q=max=min=0;
        for(i=0;i<n;i++)
        {
                if(q&&cmp(&res,&f[p][q-1])<0)
                {
                        for(j=1;j<=n;j++) if(!used[j]) { min=j; break; }
                        perm[i]=min;
                        q--;
                        used[perm[i]]=1;
                }
                else
                {
                        if(q) sub(&res,&f[p][q-1]);
                        for(j=max+1;cmp(&res,&f[p-j+max][q+j-max-1])>=0;j++)
                        {
                                sub(&res,&f[p-j+max][q+j-max-1]);
                        }
                        perm[i]=j;
                        p-=j-max;
                        q+=j-max-1;
                        used[perm[i]]=1;
                        max=j;
                }
        }
        printf("%d",perm[0]);
        for(i=1;i<n;i++) printf(" %d",perm[i]);
        printf("\n");
        return 0;
}
